
import java.awt.*;

public class Gfloy {

	int revdist;
	int numnb;
	int sleep;
	int margin;
	float acc;
	float acctomid;
	float maxspeed;
	float bouncespeed;
	float v0;
	float x;
	float y;
	float xtail;
	float ytail;
	float vx;
	float vy;
	int width;
	int height;
	int num;
	Gfloy neighbors[];
	Color color;
	int energy;
	int type;
	float xc;
	float yc;
	boolean ohraniceny;


	public Gfloy(String cr, int n, int w, int h, int t, int e, Color c) {

		width = w;
		height = h;
		num = n;
		type = t;
		energy = e;
		color = c;
		

		DecodeChrom(cr);

		x = (float) Math.random()*(width-margin*2) + margin;
		y = (float) Math.random()*(height-margin*2) + margin;
		xtail = x;
		ytail = y;

		vx = (float) Math.random()*v0-v0/2;
		vy = (float) Math.random()*v0-v0/2;

		neighbors = new Gfloy[numnb];

	}


	private void DecodeChrom(String st) {

		int temp;

		revdist = (int) ((int) st.charAt(0) - 64)*10;
		acc = (float) ((int) st.charAt(1) - 64)/100;
		acctomid = (float) ((int) st.charAt(2) - 64)/100;
		maxspeed = (float) ((int) st.charAt(3) - 64)/10;
		bouncespeed = (float) ((int) st.charAt(4) - 64)/100;
		v0 = (float) ((int) st.charAt(5) - 64)/10;
		sleep = (int) st.charAt(6) - 64;
		margin = (int) st.charAt(7) - 64;
		numnb = (int) ((int) st.charAt(8) - 64)/10;
	}

	private void DecodeChrom(GfloyParam params[]) {

	}

	public int dist(Gfloy ng)
	{
		int d,d1,d2;
		d1=(int)(x-ng.x);
		d2=(int)(y-ng.y);
		d=d1*d1+d2*d2;
		return(d);
	}
	

	public String GetColorName() {

		String s;

		if (color == Color.black) s = "ierna";
		else if (color == Color.blue) s = "Modr";
		else if (color == Color.cyan) s = "Zelenomodr";
		else if (color == Color.darkGray) s = "Tmavoed";
		else if (color == Color.gray) s = "ed";
		else if (color == Color.green) s = "Zelen";
		else if (color == Color.lightGray) s = "Svetloed";
		else if (color == Color.magenta) s = "Purpurov";
		else if (color == Color.green) s = "Zelen";
		else if (color == Color.orange) s = "Oranov";
		else if (color == Color.pink) s = "Ruov";
		else if (color == Color.red) s = "erven";
		else if (color == Color.white) s = "Biela";
		else if (color == Color.yellow) s = "Zlt";
		else s = "ierna";

		return s;

	}



	public void AssignColor(String c) {

		if (c.equals("ierna")) color = Color.white;
		else if (c.equals("ierna")) color = Color.white;
		else if (c.equals("Modr")) color = Color.white;
		else if (c.equals("Zelenomodr")) color = Color.white;
		else if (c.equals("Tmavoed")) color = Color.white;
		else if (c.equals("ed")) color = Color.white;
		else if (c.equals("Zelen")) color = Color.white;
		else if (c.equals("Svetloed")) color = Color.white;
		else if (c.equals("Purpurov")) color = Color.white;
		else if (c.equals("Oranov")) color = Color.white;
		else if (c.equals("Ruov")) color = Color.white;
		else if (c.equals("erven")) color = Color.white;
		else if (c.equals("Biela")) color = Color.white;
		else if (c.equals("lt")) color = Color.white;
		else color = Color.black;

	}


	public void GetNeighbors()
	{
		int i,j,k;
		Gfloy ng;

		for (i=0;i<numnb;i++) {
			ng=neighbors[i];;
			for (j=0;j<numnb;j++) {
				if (dist(ng.neighbors[j]) < dist(ng))
					neighbors[i]=ng.neighbors[j];
				if (ng.neighbors[j].type == 1)
					neighbors[i]=ng.neighbors[j];
			}
		}

		xc = 0;
		yc = 0;
		for (k=0;k<numnb;k++) {
			if (neighbors[k] == this) neighbors[k]=neighbors[k].neighbors[0];
			xc += neighbors[k].x;
			yc += neighbors[k].y;
		}
		xc = xc/numnb;
		yc = yc/numnb;
	}


	public void Process() {	//Sprvanie
	
		int rev;
		int i;
		int d;

		xtail = x;
		ytail = y;
		rev = -1;
		
		for (i=0;i<numnb;i++) {
			
			d = dist(neighbors[i]);
			if (d == 0)
				rev = 0;
			else if (d < revdist) {
				if (neighbors[i].type != type) {
					if (type == 1) {
						energy--;
						rev = -30;
					}
					else  {
						energy++;
						rev = 30;
					}
				}
				else
				   rev = -1;
			}
			else  {
				if (type == 1)
					rev = 0;
				else if (neighbors[i].type == 1) 
					rev = 20;
				else
					rev = 1;
			}

			if (x < neighbors[i].x)
				vx += acc*rev;
			else
				vx -= acc*rev;

			if (y < neighbors[i].y)
				vy += acc*rev;
			else
				vy -= acc*rev;
		}
	

		if (vx > maxspeed) vx = maxspeed;
		if (vx < -maxspeed) vx = -maxspeed;
		if (vy > maxspeed) vy = maxspeed;
		if (vy < -maxspeed) vy = -maxspeed;
if ((type==0 || type==1) && ohraniceny){

		if (x < 0) vx = bouncespeed;
		if (x > width) vx = -bouncespeed;
		if (y < 0) vy = bouncespeed;
		if (y > height) vy = -bouncespeed;
		}
if (type==1 && !ohraniceny){

		if (x < 0) {xtail = width; x = width;}
		if (x > width) {xtail = 0; x = 0;}
		if (y < 0) {ytail = height; y = height;}
		if (y > height) {ytail = 0; y = 0;}
}
if (type==0 && !ohraniceny){

		if (x < 0) {xtail = width - vx; vx = 0; x = width;}
		if (x > width) {xtail = vx; vx = 0; x = 0;}
		if (y < 0) {ytail = height - vy; vy = 0; y = height;}
		if (y > height) {ytail = vy; vy = 0; y = 0;}
}
		if (type == 0 && ohraniceny) {
			if (x < width/2) vx += acctomid;
			if (x > width/2) vx -= acctomid;
			if (y < height/2) vy += acctomid;
			if (y > height/2) vy -= acctomid;
		}

		x += vx;
		y += vy;


		if (energy < 1)	{
			color = Color.black;
			type = 0;
			energy = 100;
		}
		else if (energy == 110) {
			energy++;
			color = Color.orange;
			maxspeed = maxspeed + 1;
			acc = (float) (acc + 1);
		}
		else if (energy == 120) {
			energy++;
			color = Color.red;
			maxspeed = maxspeed + 1;
			acc = (float) (acc+0.1);
		}

	}


	public void Draw(Graphics g) {

		g.setColor(color);
		g.drawLine((int) xtail, (int) ytail,(int) x,(int) y);
		g.fillOval((int) x, (int) y, 3, 3);

	}

}

